"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extractCssChunksWebpackPlugin = _interopRequireDefault(require("extract-css-chunks-webpack-plugin"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var _default = function _default(_ref) {
  var _ref$cssLoaderConfigO = _ref.cssLoaderConfigOptions,
      cssLoaderConfigOptions = _ref$cssLoaderConfigO === void 0 ? {} : _ref$cssLoaderConfigO,
      _ref$sassIncludePaths = _ref.sassIncludePaths,
      sassIncludePaths = _ref$sassIncludePaths === void 0 ? [] : _ref$sassIncludePaths;
  return {
    webpack: function webpack(config, _ref2) {
      var stage = _ref2.stage;
      var loaders = [];

      var cssLoaderOptions = _objectSpread({
        importLoaders: 2,
        modules: true,
        camelCase: true,
        localIdentName: stage === "dev" ? "[name]__[local]--[hash:base64:5]" : "[hash:base64:5]",
        sourceMap: true
      }, cssLoaderConfigOptions);

      var cssLoader = {
        loader: "css-loader",
        options: cssLoaderOptions
      };
      var postcssLoader = {
        loader: "postcss-loader",
        options: {
          config: {
            // File must be named in one of these formats:
            // https://github.com/michael-ciniawsky/postcss-load-config#usage
            path: "src/configuration/"
          }
        }
      };
      var sassLoader = {
        loader: "sass-loader",
        options: {
          sourceMap: true,
          sassOptions: {
            includePaths: ["src/"].concat(_toConsumableArray(sassIncludePaths))
          }
        }
      };

      if (stage === "dev") {
        // Dev
        loaders = [{
          loader: _extractCssChunksWebpackPlugin["default"].loader,
          options: {
            hot: true
          }
        }, cssLoader, postcssLoader, sassLoader];
      } else if (stage === "node") {
        // Node
        // Don't extract css to file during node build process
        loaders = [_objectSpread({}, cssLoader, {
          loader: "css-loader",
          options: _objectSpread({}, cssLoaderOptions, {
            exportOnlyLocals: true
          })
        }), postcssLoader, sassLoader];
      } else {
        // Prod
        loaders = [_extractCssChunksWebpackPlugin["default"].loader, cssLoader, postcssLoader, sassLoader];
      }

      config.module.rules[0].oneOf.unshift({
        test: /\.s(a|c)ss$/,
        use: loaders
      }); // config.plugins.push(new ExtractCssChunks());

      return config;
    }
  };
};

exports["default"] = _default;